function CreateLaserParticle(x,y)
	local rand = math.random(1,3);
	local i;
	if rand == 1 then
		i = CreateMOPixel("MHGLPR-1");
		i.Vel.X = math.random(-1.0,1.0);
		i.Vel.Y = math.random(-1.0,1.0);		
	elseif rand == 2 then
		i = CreateMOPixel("MHGLPR-2");	
		i.Vel.X = math.random(-1.5,1.5);
		i.Vel.Y = math.random(-1.5,1.5);		
	else 
		i = CreateMOPixel("MHGLPR-3");
		i.Vel.X = math.random(-0.5,0.5);
		i.Vel.Y = math.random(-0.5,0.5);		
	end	
	i.Pos = Vector(x,y);

	MovableMan:AddMO(i);
end

function Create(self)
	if self.Magazine then
		self.ammo = self.Magazine.RoundCount
	else
		self.ammo = 0
	end
	self.Offset2 = 1.5;
	self.Range = 1000;
	self.Vibrations = 0.005; --/1000 rad
end

function Destroy(self)
end

function Update(self)
	local m = SceneMan:ShortestDistance(self.Pos, self.MuzzlePos, true);
	local an = math.atan2(m.Y,m.X)+math.random(-1000,1000)*0.001*self.Vibrations;
	local mo = Vector(m.Magnitude*math.cos(an),m.Magnitude*math.sin(an));
	local anan = math.atan2(mo.Y,mo.X);
	
	if self.Magazine then
		if self.ammo > self.Magazine.RoundCount then
			-- bullets are missing from the magazine so the gun must have been fired	
			local p = Vector();
			local ray = SceneMan:CastObstacleRay(Vector(self.MuzzlePos.X+mo.X,self.MuzzlePos.Y+mo.Y), Vector(self.Range*mo.Normalized.X,self.Range*mo.Normalized.Y), Vector(), p, self.ID, 0, 0, 0);

			if ray < 0 then
				ray = 1000;
			elseif ray > 1000 then
				ray = 1000;
			end
			ray = ray * 1.03;
			
			local dist = self.Offset2/2;
			
			local i = CreateMOPixel("MHGLPR-1");
			i.Pos = self.MuzzlePos;
			MovableMan:AddMO(i);
			while dist <= ray-self.Offset2/2 do
				CreateLaserParticle(self.MuzzlePos.X+mo.Normalized.X*dist,self.MuzzlePos.Y+mo.Normalized.Y*dist);
				dist = dist+self.Offset2;
			end
			self.ammo = self.Magazine.RoundCount;
		end	
		if self.ammo < self.Magazine.RoundCount then
			self.ammo = self.Magazine.RoundCount;
		end
	end
end