function Create(self)
	if self.Magazine then
		self.ammo = self.Magazine.RoundCount
	else
		self.ammo = 0
	end
end

function Update(self)
	if self.Magazine then
		if self.ammo > self.Magazine.RoundCount then
			-- bullets are missing from the magazine so the gun must have been fired
			
			local Parent = MovableMan:GetMOFromID(self.RootID)
			local BulletVel = self.Vel + self:RotateOffset(Vector(170,RangeRand(-3,3)))
			
			-- bullets
			local Effect = CreateMOSRotating("Shot Coalition Heavy Sniper", "Coalition.rte")
			if Effect then
				Effect.Vel = BulletVel
				Effect.Pos = self.MuzzlePos
				Effect:SetWhichMOToNotHit(Parent, 0.1)
				if MovableMan:IsActor(Parent) then
					Effect.Team = ToActor(Parent).Team;
					Effect.IgnoresTeamHits = true;
				end
				MovableMan:AddParticle(Effect)
			end
			
			for i = 1, 4 do
				Effect = CreateMOPixel("Particle Coalition Sniper Heavy", "Coalition.rte")
				if Effect then
					Effect.Vel = BulletVel
					Effect.Pos = self.MuzzlePos
					Effect:SetWhichMOToNotHit(Parent, 0.1)
					if MovableMan:IsActor(Parent) then
						Effect.Team = ToActor(Parent).Team;
						Effect.IgnoresTeamHits = true;
					end
					MovableMan:AddParticle(Effect)
				end
			end
			
			-- forward
			for i = 1, 4 do
				Effect = CreateMOSParticle("Side Thruster Blast Ball 1", "Base.rte")
				if Effect then
					Effect.Vel = self.Vel + self:RotateOffset(Vector(RangeRand(6,9),RangeRand(-3,3)))
					Effect.Pos = self.MuzzlePos
					MovableMan:AddParticle(Effect)
				end
			end
			
			-- up
			for i = 1, 5 do
				Effect = CreateMOSParticle("Tiny Smoke Ball 1", "Base.rte")
				if Effect then
					Effect.Vel = self.Vel - self:RotateOffset(Vector(RangeRand(-2,2), RangeRand(7,11)))
					Effect.Pos = self.MuzzlePos
					MovableMan:AddParticle(Effect)
				end
			end
			
			-- down
			for i = 1, 5 do
				Effect = CreateMOSParticle("Tiny Smoke Ball 1", "Base.rte")
				if Effect then
					Effect.Vel = self.Vel + self:RotateOffset(Vector(RangeRand(-2,2), RangeRand(7,11)))
					Effect.Pos = self.MuzzlePos
					MovableMan:AddParticle(Effect)
				end
			end
		end
		
		-- update the ammo counter so this script can't spawn bullets until the gun has been fired again
		self.ammo = self.Magazine.RoundCount
	end
end
