function Create(self)

	self.checkTimer = Timer();
	self.AIFired = false;
	self.alliedTeam = -2;

	self.curdist = 15;
	for i = 1,MovableMan:GetMOIDCount()-1 do
		local gun = MovableMan:GetMOFromID(i);
		if gun.PresetName == "Missile Launcher" and gun.ClassName == "HDFirearm" and SceneMan:ShortestDistance(self.Pos,ToHDFirearm(gun).MuzzlePos,SceneMan.SceneWrapsX).Magnitude < self.curdist then
			local actor = MovableMan:GetMOFromID(gun.RootID);
			if MovableMan:IsActor(actor) then
				if ToActor(actor):IsPlayerControlled() then
					self.parent = ToAHuman(actor);
					self.parentgun = ToHDFirearm(gun);
					self.RotAngle = ToActor(actor):GetAimAngle(true);

					self.parent:GetController():SetState(Controller.WEAPON_RELOAD,true);
				else
					self.AIFired = true;
					self.alliedTeam = ToActor(actor).Team;
				end
				self.Vel = actor.Vel + Vector(10,0):RadRotate(ToActor(actor):GetAimAngle(true));
				break;
			end
		end
	end

	self.raylength = 1000;
	self.rayPixSpace = 10;

	self.dots = math.floor(self.raylength/self.rayPixSpace);

end

function Update(self)

	if MovableMan:IsActor(self.parent) and self.parentgun ~= nil and self.parent.EquippedItem.ID == self.parentgun.ID then

		if self.checkTimer:IsPastSimMS(100) or self.targetPos == nil then
			self.checkTimer:Reset();

			if self.targetPos ~= nil then
				self.lastTarget = self.targetPos;
			end

			self.targetPos = self.parentgun.MuzzlePos + Vector(SceneMan:ShortestDistance(self.Pos,self.parentgun.MuzzlePos,SceneMan.SceneWrapsX).Magnitude+100,0):RadRotate(self.parent:GetAimAngle(true));

			if SceneMan.SceneWrapsX == true then
				if self.targetPos.X > SceneMan.SceneWidth then
					self.targetPos = Vector(self.targetPos.X - SceneMan.SceneWidth,self.targetPos.Y);
				elseif self.targetPos.X < 0 then
					self.targetPos = Vector(SceneMan.SceneWidth + self.targetPos.X,self.targetPoss.Y);
				end
			end

			for i = 1, self.dots do
				local checkPos = self.parentgun.MuzzlePos + Vector((i/self.dots)*self.raylength,0):RadRotate(self.parent:GetAimAngle(true));
				if SceneMan.SceneWrapsX == true then
					if checkPos.X > SceneMan.SceneWidth then
						checkPos = Vector(checkPos.X - SceneMan.SceneWidth,checkPos.Y);
					elseif checkPos.X < 0 then
						checkPos = Vector(SceneMan.SceneWidth + checkPos.X,checkPos.Y);
					end
				end
				local terrCheck = SceneMan:GetTerrMatter(checkPos.X,checkPos.Y);
				if terrCheck == 0 then
					local moCheck = SceneMan:GetMOIDPixel(checkPos.X,checkPos.Y);
					if moCheck ~= 255 then
						self.targetPos = checkPos;
						break;
					end
				else
					self.targetPos = checkPos;
					break;
				end
			end

			local laserPar = CreateMOPixel("Coalition RPG Laser Particle");
			laserPar.Pos = self.targetPos;
			MovableMan:AddParticle(laserPar);

			if self.lastTarget ~= nil then
				local drawVector = SceneMan:ShortestDistance(self.lastTarget,self.targetPos,SceneMan.SceneWrapsX);
				local drawLine = math.ceil(drawVector.Magnitude/5);
				for i = 1, drawLine do
					local laserPar = CreateMOPixel("Coalition RPG Laser Particle 2");
					laserPar.Pos = self.lastTarget + Vector(i*5,0):RadRotate(drawVector.AbsRadAngle);
					MovableMan:AddParticle(laserPar);
				end
			end

		end

		self.RotAngle = SceneMan:ShortestDistance(self.Pos,self.targetPos,SceneMan.SceneWrapsX).AbsRadAngle;

		self.parent:GetController():SetState(Controller.WEAPON_FIRE,false);
		self.parentgun:Deactivate();
	end

	if self.AIFired == true then
		if self.target ~= nil and self.target.ID ~= 255 then
			self.RotAngle = SceneMan:ShortestDistance(self.Pos,self.target.Pos + (self.Vel*-3),SceneMan.SceneWrapsX).AbsRadAngle;
			if self.targetDist ~= nil then
				if self.armed == false and self.targetDist < self.target.Radius + self.armedRange then
					self.armed = true;
				end
				if self.armed == true and SceneMan:ShortestDistance(self.Pos,self.target.Pos,SceneMan.SceneWrapsX).Magnitude > self.targetDist then
					self:GibThis();
				end
			end
			self.targetDist = SceneMan:ShortestDistance(self.Pos,self.target.Pos,SceneMan.SceneWrapsX).Magnitude;
		else
			self.curdist = self.raylength;
			for actor in MovableMan.Actors do
				local dist = SceneMan:ShortestDistance(self.Pos,actor.Pos,SceneMan.SceneWrapsX);
				if actor.Team ~= self.alliedTeam and dist.Magnitude < self.curdist and SceneMan:CastStrengthRay(self.Pos,dist:SetMagnitude(dist.Magnitude-actor.Radius),0,Vector(0,0),5,0,SceneMan.SceneWrapsX) == false then
					self.target = actor;
				end
			end
			self.targetDist = nil;
		end
	end

end